#!/usr/bin/env python

import ut
import v

def new(p, v_):
	e = ut.Empty()
	e.typ = 'line'
	e.p = p
	e.v = v_
	e.on_line_p = lambda t: v.op2( '+', p, v.op1('*', e.v, t) )
	e.get_p_t = lambda : ( p, e.on_line_p(1) )

	def tr_by_func(f):
		(p, t) = map( f, e.get_p_t() )
		return new_p2_no_unit(p, t) # no unit !!!
	e.tr_by_func = tr_by_func

        ###

	#
	# (e.p, e.v) is plane
	#

	e.is_plane_side = lambda p: v.dot_product( e.v, v.sub(p, e.p) ) >= 0

	def cross_plane_line(other_line):
		l = other_line
		base = v.dot_product(l.v, e.v)
		if base == 0:
			return []
		t = float( v.dot_product( v.sub(e.p, l.p), e.v ) ) / base
		return l.on_line_p(t)
	e.cross_plane_line = cross_plane_line

	return e

new_p2_no_unit = lambda p, t: new( p, v.sub(t, p) )
new_p2 = lambda p, t: new( p, v.sub_unit(t, p) )

x1 = new( [0,0,0], v.x1 )
y1 = new( [0,0,0], v.y1 )
z1 = new( [0,0,0], v.z1 )

# EOF
