#!/usr/bin/env python

import math
import ut
import v
import line

def new(r, rev=False):
	e = ut.Empty()
	e.typ = 'cylx'
	e.r = r

	def l2g(p):
		(x, y, z) = p
		rad = x/e.r
		r = z
		return [ r*math.cos(r), r*math.sin(r), y ]

	def g2l(p):
		(x, y, z) = p
		rad = math.atan2(y, x)
		r = v.len1( [x,y,0] )
		return [ e.r*rad, z, r ]

	dval = lambda d: d if not rev else { 'l2g': 'g2l', 'g2l': 'l2g' }.get(d, 'g2l')
	e.tr_p = lambda d, p: { 'l2g': l2g, 'g2l': g2l }.get( dval(d), l2g)(p)
	e.tr_line = lambda d, l: l.tr_by_func( lambda p: e.tr_p(d, p) )

	def tr(d, targ, typ='p'):
		dic = {
			'p': e.tr_p,
			'line': e.tr_line,
		}
		f = dic.get( ut.get_typ(targ, typ), e.tr_p )
		return f(d, targ)
	e.tr = tr

	e.rev = lambda : new(e.r, not rev)

	return e
# EOF
