#!/usr/bin/env python

import ut
import v
import line
import ax

def opt(lst):
	r = []
	is_last_ax = lambda : r and ut.get_typ(r[-1]) == 'ax'
	for x in lst:
		if ut.get_typ(x) == 'ax' and is_last_ax():
			r[-1] = r[-1].compo(x)
		else:
			r.append(x)
	return r

dval = lambda d, rev: d if not rev else { 'l2g': 'g2l', 'g2l': 'l2g' }.get(d, 'g2l')

def tr_p(lst, d, p):
	if d == 'g2l':
		lst = reversed(lst)
	return reduce( lambda p, x: x.tr_p(d, p), lst, p )

def tr_line(lst, d, l):
	return l.tr_by_func( lambda p: tr_p(lst, d, p) )

def tr(lst, d, targ, typ='p'):
	dic = {
		'p': tr_p,
		'line': tr_line,
	}
	f = dic.get( ut.get_typ(targ, typ), tr_p )
	return f(lst, d, targ)

# EOF
