#!/usr/bin/env python

import math

zero = [0,0,0]
one = [1,1,1]
x1 = [1,0,0]
y1 = [0,1,0]
z1 = [0,0,1]
x_nega = [-1,0,0]
y_nega = [0,-1,0]
z_nega = [0,0,-1]
all = lambda e: [e,e,e]

def op1(op, v, p):
	ops = {
		'+': lambda e: e + p,
		'-': lambda e: e - p,
		'*': lambda e: e * p,
		'/': lambda e: e / float(p),
	}
	f = ops.get( op, lambda e: None )
	return map(f, v)

def op2(op, va, vb):
	ops = {
		'+': lambda (a, b): a + b,
		'-': lambda (a, b): a - b,
		'*': lambda (a, b): a * b,
		'/': lambda (a, b): a / float(b),
	}
	f = ops.get( op, lambda (a, b): None )
	return map( f, zip(va, vb) )

nega = lambda v: map( lambda e: -e, v )

lst_add = lambda vlst: map( sum, zip(*vlst) )

dot_product = lambda va, vb: sum( op2('*', va, vb) )

len2 = lambda v: dot_product(v, v)

len1 = lambda v: math.sqrt( len2(v) )

unit = lambda v: ( lambda l: op1('/', v, l) if l != 0 else z1 )( len1(v) )

sub = lambda a, b: op2('-', a, b)

sub_unit = lambda a, b: unit( sub(a, b) )
sub_len = lambda a, b: len1( sub(a, b) )

def dot_product_len(v_targ, v_base):
	base = dot_product(v_base, v_base)
	return float( dot_product(v_targ, v_base) ) / base if base != 0 else 0

def cross_product(va, vb):
	jks = map( lambda i: ( (i+1)%3, (i+2)%3 ), range(3) )
	return map( lambda (j, k): va[j] * vb[k] - va[k] * vb[j], jks )

cross_product_unit = lambda va, vb: unit( cross_product(va, vb) )

p3_to_nv = lambda o, a, b: cross_product_unit( sub(a, o), sub(b, o) )

# EOF
